"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

require("antd/es/modal/style");

var _modal = _interopRequireDefault(require("antd/es/modal"));

require("antd/es/form/style");

var _form = _interopRequireDefault(require("antd/es/form"));

require("antd/es/row/style");

var _row = _interopRequireDefault(require("antd/es/row"));

require("antd/es/button/style");

var _button = _interopRequireDefault(require("antd/es/button"));

var _react = _interopRequireWildcard(require("react"));

require("./index.less");

var _data = require("../data");

var _RenderItemGroup = _interopRequireDefault(require("../FormComp/RenderItemGroup"));

var _ValueFormat = _interopRequireDefault(require("../utils/ValueFormat.js"));

var _IconNode = _interopRequireDefault(require("../components/IconNode"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var StandardModal =
/*#__PURE__*/
function (_React$Component) {
  _inherits(StandardModal, _React$Component);

  _createClass(StandardModal, null, [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps) {
      var title = nextProps.title,
          footer = nextProps.footer,
          footerButtonGroup = nextProps.footerButtonGroup,
          hideFooter = nextProps.hideFooter,
          fieldStatus = nextProps.fieldStatus;
      return {
        bodyMaxHeight: "".concat(document.body.offsetHeight - (title ? 55 : 0) - (footer || footerButtonGroup ? 55 : 0) - 160 - 32 + (fieldStatus && fieldStatus !== 'default' || hideFooter ? 55 : 0), "px")
      };
    }
  }]);

  // modalRef = React.createRef()
  function StandardModal(props) {
    var _this;

    _classCallCheck(this, StandardModal);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(StandardModal).call(this, props));
    _this.modalFormRef = _react["default"].createRef();

    _this.initBodyMaxHeight = function () {
      var _this$props = _this.props,
          title = _this$props.title,
          footer = _this$props.footer,
          footerButtonGroup = _this$props.footerButtonGroup,
          hideFooter = _this$props.hideFooter,
          fieldStatus = _this$props.fieldStatus;

      _this.setState({
        bodyMaxHeight: "".concat(document.body.offsetHeight - (title ? 55 : 0) - (footer || footerButtonGroup ? 55 : 0) - 160 - 32 + (fieldStatus && fieldStatus !== 'default' || hideFooter ? 55 : 0), "px")
      });
    };

    _this.handleSubmit = function () {
      var _this$props2 = _this.props,
          type = _this$props2.type,
          formItemGroup = _this$props2.formItemGroup,
          onSubmit = _this$props2.onSubmit;

      if (type === 'form') {
        _this.modalFormRef.current.validateFields().then(function (values) {
          if (Object.prototype.hasOwnProperty.call(values, false)) {
            delete values["false"]; // TODO 自定义结构会莫名的出来一个false字段
          }

          var resultValues = (0, _ValueFormat["default"])(values, formItemGroup);

          if (onSubmit) {
            onSubmit(_objectSpread({}, resultValues)); // this.clearAllFieldsValue()
          }
        })["catch"](function (errorInfo) {// TODO 滚动条需要滚动定位到第一条数据 label for=`modal-form_${errorInfo.errorFields[0].name}`
          // console.log('表单填写有误', errorInfo, '第一条数据', `modal-form_${errorInfo.errorFields[0].name}`)
        });
      } else {
        // 没有表单数组 formItemGroup 配置
        onSubmit && onSubmit();
      }
    };

    _this.clearAllFieldsValue = function () {// let allFields = {}
      // Object.keys(this.modalFormRef.getFieldsValue()).map((item) => allFields[item] = undefined)
      // this.modalFormRef.setFieldsValue(allFields) // 直接清空表单的赋值(initialValues传值如果没有前后赋值没有全部带上所有字段，则会默认又使用之前的部分未传参字段)
      // this.modalFormRef.current.resetFields()
    };

    _this.onAfterClose = function () {
      var afterClose = _this.props.afterClose; // if (type === 'form') this.clearAllFieldsValue()

      if (afterClose) afterClose();
    };

    _this.handleCancel = function () {
      var onCancel = _this.props.onCancel; // if (type === 'form') this.clearAllFieldsValue()

      if (onCancel) onCancel();
    };

    _this.renderButtonGroup = function () {
      var _this$props3 = _this.props,
          fieldStatus = _this$props3.fieldStatus,
          _this$props3$hideFoot = _this$props3.hideFooter,
          hideFooter = _this$props3$hideFoot === void 0 ? false : _this$props3$hideFoot,
          footerButtonGroup = _this$props3.footerButtonGroup,
          confirmLoading = _this$props3.confirmLoading,
          cancelText = _this$props3.cancelText,
          confirmText = _this$props3.confirmText,
          okText = _this$props3.okText;
      if (fieldStatus && fieldStatus !== 'default') return null; // 弹窗配置 fieldStatus='disabled' 或 'viewOnly 时，隐藏底部栏

      if (hideFooter) return null;

      if (footerButtonGroup) {
        if (Array.isArray(footerButtonGroup)) {
          if (footerButtonGroup.length === 0) return null;
          return _react["default"].createElement(_react["default"].Fragment, null, footerButtonGroup.map(function (item) {
            return _react["default"].createElement(_button["default"], {
              key: item.name,
              type: item.type ? item.type : 'primary',
              icon: _react["default"].createElement(_IconNode["default"], {
                icon: item.icon
              }),
              ghost: item.ghost,
              disabled: item.disabled,
              loading: item.loading,
              onClick: item.fn ? function (e) {
                return item.fn(item, _this.modalFormRef.current, _this.props, e);
              } : null
            }, item.name);
          }));
        } else {
          return footerButtonGroup;
        }
      }

      return _react["default"].createElement(_react["default"].Fragment, null, _react["default"].createElement(_button["default"], {
        key: "submit",
        type: "primary",
        loading: confirmLoading,
        onClick: _this.handleSubmit
      }, confirmText || okText || '确定'), _react["default"].createElement(_button["default"], {
        key: "back",
        onClick: _this.handleCancel
      }, cancelText || '取消'));
    };

    _this.renderFormItemGroup = function () {
      var _this$props4 = _this.props,
          fieldStatus = _this$props4.fieldStatus,
          formItemGroup = _this$props4.formItemGroup,
          getFormFields = _this$props4.getFormFields,
          _this$props4$size = _this$props4.size,
          size = _this$props4$size === void 0 ? 'md' : _this$props4$size;

      if (Array.isArray(formItemGroup)) {
        return _react["default"].createElement(_RenderItemGroup["default"], _extends({
          size: size,
          form: _this.modalFormRef,
          getFormFields: getFormFields,
          itemGroup: formItemGroup,
          fieldStatus: fieldStatus
        }, _this.props));
      }

      return formItemGroup;
    };

    _this.state = {
      // 160px代表上下空白间距， 32px为内容区内部的上下padding值
      bodyMaxHeight: "auto"
    };
    return _this;
  }

  _createClass(StandardModal, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      window.addEventListener('resize', this.initBodyMaxHeight);
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      var _this$props5 = this.props,
          hideFooter = _this$props5.hideFooter,
          fieldStatus = _this$props5.fieldStatus;
      if (hideFooter !== prevProps.hideFooter || fieldStatus !== prevProps.fieldStatus) this.initBodyMaxHeight();
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      window.removeEventListener('resize', this.initBodyMaxHeight);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props6 = this.props,
          children = _this$props6.children,
          className = _this$props6.className,
          style = _this$props6.style,
          _this$props6$size = _this$props6.size,
          size = _this$props6$size === void 0 ? 'md' : _this$props6$size,
          type = _this$props6.type,
          formItemGroup = _this$props6.formItemGroup,
          title = _this$props6.title,
          visible = _this$props6.visible,
          formPrefix = _this$props6.formPrefix,
          formPostfix = _this$props6.formPostfix,
          initialValues = _this$props6.initialValues,
          hideRequiredMark = _this$props6.hideRequiredMark,
          footer = _this$props6.footer,
          bodyStyle = _this$props6.bodyStyle,
          _this$props6$fieldSta = _this$props6.fieldStatus,
          fieldStatus = _this$props6$fieldSta === void 0 ? 'defalut' : _this$props6$fieldSta;
      return _react["default"].createElement(_modal["default"], _extends({
        maskClosable: false,
        destroyOnClose: true,
        forceRender: true
      }, this.props, {
        visible: visible,
        title: title,
        width: _data.general.modalSize[size].width || _data.general.modalSize.sm.width,
        footer: this.renderButtonGroup() || footer,
        className: "standardModal ".concat(className || '', " ").concat(fieldStatus === 'viewOnly' ? 'is-view' : ''),
        style: _objectSpread({
          top: '80px'
        }, style),
        bodyStyle: _objectSpread({
          maxHeight: this.state.bodyMaxHeight,
          overflowY: 'scroll'
        }, bodyStyle),
        onCancel: this.handleCancel,
        afterClose: this.onAfterClose,
        onOk: this.handleSubmit // ref={this.modalRef}

      }), children, type === 'form' && _react["default"].createElement(_form["default"], {
        ref: this.modalFormRef,
        onFinish: this.handleSubmit,
        hideRequiredMark: fieldStatus === 'viewOnly' || hideRequiredMark,
        initialValues: initialValues,
        scrollToFirstError: true,
        className: "modalForm"
      }, _react["default"].createElement(_row["default"], {
        type: "flex"
      }, formPrefix && formPrefix(this.modalFormRef, this.props), formItemGroup ? this.renderFormItemGroup() : null, formPostfix && formPostfix(this.modalFormRef, this.props))));
    }
  }]);

  return StandardModal;
}(_react["default"].Component);

var _default = StandardModal;
exports["default"] = _default;