"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

require("antd/es/card/style");

var _card = _interopRequireDefault(require("antd/es/card"));

require("antd/es/table/style");

var _table = _interopRequireDefault(require("antd/es/table"));

require("antd/es/dropdown/style");

var _dropdown = _interopRequireDefault(require("antd/es/dropdown"));

require("antd/es/menu/style");

var _menu = _interopRequireDefault(require("antd/es/menu"));

require("antd/es/popconfirm/style");

var _popconfirm = _interopRequireDefault(require("antd/es/popconfirm"));

require("antd/es/divider/style");

var _divider = _interopRequireDefault(require("antd/es/divider"));

var _react = _interopRequireWildcard(require("react"));

var _lodash = _interopRequireDefault(require("lodash"));

var _classnames = _interopRequireDefault(require("classnames"));

var _index = require("../data/index");

require("./index.less");

var _icons = require("@ant-design/icons");

var _components = require("../components");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var StandardTable = _react["default"].forwardRef(function (props, ref) {
  var _useState = (0, _react.useState)(false),
      _useState2 = _slicedToArray(_useState, 2),
      popVisibleIndex = _useState2[0],
      setPopVisibleIndex = _useState2[1];

  var _useState3 = (0, _react.useState)({}),
      _useState4 = _slicedToArray(_useState3, 2),
      popRow = _useState4[0],
      setPopRow = _useState4[1];

  var handleTableChange = function handleTableChange(pagination, filters, sorter) {
    var onChange = props.onChange;

    if (onChange) {
      onChange(pagination, filters, sorter);
    }
  };

  var _props$data = props.data,
      data = _props$data === void 0 ? {} : _props$data,
      rowKey = props.rowKey,
      rowSelection = props.rowSelection,
      columns = props.columns,
      hideOrderNumber = props.hideOrderNumber,
      _props$orderNumber = props.orderNumber,
      orderNumber = _props$orderNumber === void 0 ? {} : _props$orderNumber,
      className = props.className,
      emptyText = props.emptyText,
      rest = _objectWithoutProperties(props, ["data", "rowKey", "rowSelection", "columns", "hideOrderNumber", "orderNumber", "className", "emptyText"]);

  (0, _react.useEffect)(function () {
    setPopVisibleIndex(false);
  }, [data]);
  var resetColumns = [_objectSpread({
    width: 58,
    align: 'center',
    title: '序号',
    key: 'orderNum',
    // fixed: 'left',
    // render: (text, o, index) => pagination ?  (pagination.current - 1) * pagination.pageSize + index + 1 : index + 1,
    render: function render(text, record, index) {
      return index + 1;
    }
  }, orderNumber)];
  var _data$list = data.list,
      list = _data$list === void 0 ? [] : _data$list,
      pagination = data.pagination;

  var paginationProps = _objectSpread({
    // showQuickJumper: true,
    className: 'spec-pagination',
    showSizeChanger: true,
    pageSizeOptions: ['5', '10', '15', '20', '30', '50'],
    showTotal: function showTotal(total, range) {
      return "".concat(range[0], "-").concat(range[1], "\u6761 \u5171").concat(total, "\u6761");
    }
  }, pagination);

  if (columns) {
    columns.map(function (colItem) {
      if (colItem.type === 'action') {
        colItem.width = colItem.width || (colItem.buttonGroup.length > 1 ? 120 : 80);
        colItem.align = 'center';
        colItem.title = colItem.title || '操作';
        colItem.key = 'control'; // colItem.fixed = colItem.fixed || 'right'

        colItem.render = function (text, record, rowIndex) {
          var btnIsHide = function btnIsHide(isHide) {
            if (!isHide) return false;

            if (typeof isHide === 'function') {
              return isHide(text, record, rowIndex);
            }

            return isHide;
          }; // 按钮列表组


          var renderButtonGroup = function renderButtonGroup(buttonGroup) {
            if (!buttonGroup) return '-';

            var btn = function btn(bItem, index) {
              if (bItem.render) return bItem.render;

              if (bItem.code && _lodash["default"].findIndex(_index.funcCode.btnFuncCodes, function (btnItem) {
                return btnItem.code === bItem.code;
              }) !== -1) {
                // 如果有配置code，则使用func.code.js里面配置的名称
                bItem = Object.assign(bItem, _index.funcCode.btnFuncCodes[_lodash["default"].findIndex(_index.funcCode.btnFuncCodes, function (btnItem) {
                  return btnItem.code === bItem.code;
                })]);
              }

              return _react["default"].createElement("span", {
                key: bItem.code
              }, index !== 0 && _react["default"].createElement(_divider["default"], {
                type: "vertical"
              }), bItem.code === 'codeBtnDelete' ? _react["default"].createElement(_popconfirm["default"], {
                placement: "topRight",
                title: bItem.confirmText ? bItem.confirmText(text, record, rowIndex) : '',
                icon: _react["default"].createElement(_icons.QuestionCircleOutlined, null),
                onConfirm: bItem.fn ? function () {
                  return bItem.fn(text, record, rowIndex);
                } : null
              }, _react["default"].createElement("a", {
                key: bItem.code,
                type: bItem.type ? bItem.type : 'primary',
                icon: _react["default"].createElement(_components.IconNode, {
                  icon: bItem.icon
                }),
                disabled: bItem.disabled
              }, bItem.exName || bItem.name)) : _react["default"].createElement("a", {
                key: bItem.code,
                type: bItem.type ? bItem.type : 'primary',
                icon: _react["default"].createElement(_components.IconNode, {
                  icon: bItem.icon
                }),
                disabled: bItem.disabled,
                style: btnIsHide(bItem.isHide) ? {
                  display: 'none'
                } : {},
                onClick: bItem.fn ? function () {
                  return bItem.fn(text, record, rowIndex);
                } : null
              }, bItem.exName || bItem.name));
            };

            var menu = function menu(group) {
              return _react["default"].createElement(_menu["default"], {
                className: "spec-table-dropdown"
              }, group.map(function (gItem) {
                if (gItem.code && _lodash["default"].findIndex(_index.funcCode.btnFuncCodes, function (btnItem) {
                  return btnItem.code === gItem.code;
                }) !== -1) {
                  // 如果有配置code，则使用func.code.js里面配置的名称
                  gItem = Object.assign(gItem, _index.funcCode.btnFuncCodes[_lodash["default"].findIndex(_index.funcCode.btnFuncCodes, function (btnItem) {
                    return btnItem.code === gItem.code;
                  })]);
                }

                return _react["default"].createElement(_menu["default"].Item, {
                  key: gItem.code,
                  disabled: gItem.disabled,
                  style: btnIsHide(gItem.isHide) ? {
                    display: 'none'
                  } : {}
                }, gItem.code === 'codeBtnDelete' ? _react["default"].createElement("a", {
                  disabled: gItem.disabled,
                  onClick: gItem.fn ? function () {
                    setPopVisibleIndex(rowIndex);
                    setPopRow(gItem);
                  } : null
                }, gItem.exName || gItem.name) : _react["default"].createElement("a", {
                  onClick: gItem.fn ? function () {
                    return gItem.fn(text, record, rowIndex);
                  } : null,
                  disabled: gItem.disabled
                }, gItem.exName || gItem.name));
              }));
            };

            var recombinationGroup = []; // 重组数据
            // 类型为数组

            if (Array.isArray(buttonGroup)) recombinationGroup = buttonGroup.filter(function (item) {
              return item && !btnIsHide(item.isHide);
            }); // 排除隐藏isHide的数据
            // 类型为方法

            if (typeof buttonGroup === 'function') recombinationGroup = buttonGroup(text, record, rowIndex).filter(function (item) {
              return item && !btnIsHide(item.isHide);
            }); // 方法返回数组结构
            // 判断是否是数组且长度大于0时 ？{如下结构渲染} ： {按buttonGroup返回的node渲染}

            if (Array.isArray(buttonGroup) || typeof buttonGroup === 'function') {
              // 判断提供数据长度是否大于3，如果超过3个，则后面从第4个开始会在dropdown组件中渲染
              if (recombinationGroup.length > 2) {
                var forGroup = recombinationGroup.slice(0, 1);
                var forDrop = recombinationGroup.slice(1);
                return _react["default"].createElement(_react["default"].Fragment, null, forGroup.map(function (fItem, index) {
                  return index < 1 ? btn(fItem, index) : null;
                }), _react["default"].createElement(_divider["default"], {
                  type: "vertical"
                }), _react["default"].createElement(_popconfirm["default"], {
                  placement: "topRight",
                  visible: popVisibleIndex === rowIndex,
                  onCancel: function onCancel() {
                    return setPopVisibleIndex('');
                  },
                  icon: _react["default"].createElement(_icons.QuestionCircleOutlined, null),
                  title: popRow.confirmText ? popRow.confirmText(text, record, rowIndex) : '',
                  onConfirm: popRow.fn ? function () {
                    popRow.fn(text, record, rowIndex);
                    setPopVisibleIndex('');
                  } : null,
                  trigger: "click"
                }, _react["default"].createElement(_dropdown["default"], {
                  overlay: menu(forDrop),
                  placement: "bottomRight"
                }, _react["default"].createElement("a", {
                  type: "primary"
                }, "\u66F4\u591A ", _react["default"].createElement(_icons.DownOutlined, null)))));
              }

              return _react["default"].createElement(_react["default"].Fragment, null, recombinationGroup.map(function (bgItem, index) {
                return btn(bgItem, index);
              }));
            }

            return buttonGroup;
          };

          return _react["default"].createElement(_react["default"].Fragment, null, renderButtonGroup(colItem.buttonGroup));
        };
      } else if (!colItem.render) {
        // 若未配置render，则给加个默认的返回方法
        colItem.render = function (text, record, rowIndex) {
          return text || '-';
        };

        return colItem;
      }

      return colItem;
    });
    resetColumns = hideOrderNumber ? columns : resetColumns.concat(columns);
  }

  return _react["default"].createElement(_card["default"], {
    className: (0, _classnames["default"])('standard-table', className),
    bordered: false,
    ref: ref
  }, _react["default"].createElement(_table["default"], _extends({
    rowKey: rowKey || 'id',
    rowSelection: rowSelection ? _objectSpread({}, rowSelection, {
      columnWidth: 30
    }) : rowSelection,
    dataSource: list,
    pagination: !pagination ? false : paginationProps,
    onChange: handleTableChange,
    columns: resetColumns,
    locale: {
      filterConfirm: '确定',
      filterReset: '重置',
      emptyText: emptyText || '暂无数据'
    }
  }, rest)));
});

var _default = StandardTable;
exports["default"] = _default;