"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

require("antd/es/tree-select/style");

var _treeSelect = _interopRequireDefault(require("antd/es/tree-select"));

var _react = _interopRequireWildcard(require("react"));

require("./index.less");

var _utils = require("../../utils");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var TreeNode = _treeSelect["default"].TreeNode;

var RefactorTreeSelect = function RefactorTreeSelect(props) {
  var _props$treeData = props.treeData,
      treeData = _props$treeData === void 0 ? [] : _props$treeData,
      value = props.value,
      showFullLevel = props.showFullLevel,
      _props$separator = props.separator,
      separator = _props$separator === void 0 ? '/' : _props$separator,
      disabled = props.disabled,
      fieldStatus = props.fieldStatus,
      _props$treeOptionName = props.treeOptionName,
      treeOptionName = _props$treeOptionName === void 0 ? {
    title: 'title',
    value: 'value',
    children: 'children'
  } : _props$treeOptionName,
      placeholder = props.placeholder,
      protoTreeNode = props.protoTreeNode,
      _onSelect = props.onSelect,
      otherProps = _objectWithoutProperties(props, ["treeData", "value", "showFullLevel", "separator", "disabled", "fieldStatus", "treeOptionName", "placeholder", "protoTreeNode", "onSelect"]);

  var _useState = (0, _react.useState)(null),
      _useState2 = _slicedToArray(_useState, 2),
      fullLevelName = _useState2[0],
      setFullLevelName = _useState2[1];

  var renderTreeNode = function renderTreeNode(data, dataOptionName, nodeProps) {
    return data.map(function (item) {
      if (item[dataOptionName.children] && item[dataOptionName.children].length > 0) {
        return _react["default"].createElement(TreeNode, _extends({
          title: item[dataOptionName.title],
          key: item[dataOptionName.value],
          value: item[dataOptionName.value]
        }, nodeProps), renderTreeNode(item[dataOptionName.children], dataOptionName));
      }

      return _react["default"].createElement(TreeNode, _extends({
        title: item[dataOptionName.title],
        key: item[dataOptionName.value],
        value: item[dataOptionName.value]
      }, nodeProps));
    });
  };

  (0, _react.useEffect)(function () {
    if (value) {
      // 获取选中节点相关数据：包括当前完整数据值、当前父节点以上层层级节点数据集合及id集合
      var nodeInfo = (0, _utils.getParentNodes)(treeData, value, {
        childrenParam: treeOptionName.children,
        keyParam: treeOptionName.value
      });
      setFullLevelName(renderParenName(nodeInfo));
    } else {
      // value，无值时
      setFullLevelName(null);
    }
  }, [value, treeData]);

  var renderParenName = function renderParenName(selectNodeInfo) {
    if (selectNodeInfo.nodeParent.length > 0) {
      var parentItems = selectNodeInfo.nodeParent; // 当前查找到的父级节点拼合当前节点的标题字段值进行显示

      return parentItems.reverse().map(function (item) {
        return item[treeOptionName.title];
      }).concat(selectNodeInfo.matchNode[0][treeOptionName.title]).join(separator);
    }

    return selectNodeInfo.matchNode.length > 0 && selectNodeInfo.matchNode[0][treeOptionName.title];
  };

  var renderTreeSelectNode = function renderTreeSelectNode() {
    return _react["default"].createElement(_treeSelect["default"], _extends({
      placeholder: placeholder,
      value: value
    }, otherProps, {
      disabled: disabled,
      onSelect: function onSelect(value, node, extra) {
        var newNodeInfo = (0, _utils.getParentNodes)(treeData, value, {
          childrenParam: treeOptionName.children,
          keyParam: treeOptionName.value
        });
        setFullLevelName(renderParenName(newNodeInfo));
        if (_onSelect) _onSelect(value, node, extra);
      }
    }), renderTreeNode(treeData, treeOptionName, protoTreeNode || {}));
  };

  if (fieldStatus === 'viewOnly') return fullLevelName || '-'; // 只读显示时，只返回文本

  return _react["default"].createElement(_react["default"].Fragment, null, showFullLevel ? _react["default"].createElement("div", {
    className: "refactor-tree-select ".concat(disabled ? 'refactor-disabled' : ''),
    title: fullLevelName || ''
  }, renderTreeSelectNode(), _react["default"].createElement("span", {
    className: "refactor-tree-select-extra"
  }, fullLevelName)) : renderTreeSelectNode());
};

var _default = RefactorTreeSelect;
exports["default"] = _default;