---
name: 表单组
menu: 配置化表单
---

# 配置类表单组

> 用于通用弹窗内配置表单组

## API

```
import {FormItemGroup} from 'fan-standard-comp';
```
### API
| 参数      | 说明                                      | 类型         | 默认值 | 参考值 |
|----------|------------------------------------------|-------------|-------|-------|
| itemGroup | 表单控件配置项组 | Array | - |- |
| size | 栅格下label与控件布局比例 | String | md |可选:xs,sm,md,lg,lg |
| displayLayout | 自定义标签与控件栅格值 | Object |  |{labelCol: { span: 7 },  wrapperCol: { span: 15 },} |
| ~~disabledAll~~(弃用，使用 fieldStatus='disabled'替换)| 控件是否禁用 | Boolean | false | |
| fieldStatus | 配置化表单展示状态：“viewOnly 只显示值不显示控件”或者"disabled:控件禁用" | String | 'defalut' | |
      

### itemGroup API

| 参数字段      | 说明  |   类型   |必选项| 参考值|
|----------|------|-------------|------|------|
| label | 标签显示值 | String | 是 | |
| type | 当前控件类型 | String | 是 | （基础类型：input\password\select等，自定义：custom，仅显示标题：title\html）|
| description | 描述 | String | 否 | |
| isHide | 是否隐藏当前配置的组件 | Boolean/Function(fieldValues, form, fieldStatus)| 否 | fieldValues指当前配置表单内部的所有控件值，form指当前弹窗内部的表单实例 |
| customRender | 自定义表单控件结构(必须配合type="custom"使用) | Function(form,item,fieldStatus) | 否  | 
| display |显示模式，side与其他控件并列展示或者block独占一行，若为对象则按对象定义的栅格展示 | String或Object | 否 | 'side';'block';{labelCol:{ span: 4 }, wrapperCol: { span: 19}}  |
| colSpan | 当前标签控件占用的栅格数 | Number | 否| |
| protoFormItem | Form.Item 原始API | Objcet | 否|[官网API](https://ant.design/components/form-cn/#Form.Item)  |
| onChange | 控件更新事件 | Function | 否 | |
| 其他 | 其他配置项目可查看 FieldComponent |  | ||

