---
menu: 通用组件
name: StandardFilter 筛选栏
---

# 筛选工具栏

> 用在表格上方的筛选工具栏

## 基础用法

    const StandardFilterDemo = ()=> {
	    const controlBtn = [ {
	      name: '被禁用',
	      disabled: true, // 表示禁用
	      code: 'codeBtnImport', // 导入 直接配置code可不用配置 name 与 icon
	      fn: () => console.log('do something'),
	    },
	    {
	      name: '导入',
	      exName: '名称优先name（同code内定义的name）',
	     isHide: true, // 隐藏掉的按钮
	      code: 'codeBtnImport', // 导入 直接配置code可不用配置 name 与 icon
	      fn: () => console.log('do something'),
	    }
	  ]const controlFilters = [
    {
      label: (<span>是否系统内置&nbsp;
        <Tooltip title="只有超管可以选择“是”，其他角色默认选择“否”"><SpecIcon name="info" /></Tooltip>
              </span>),
      type: 'input',
      filedName: 'name',
      componentStyle: {
        width: '300px'
      },
      protoConfig: {
        // maxLength: 2,
        // type: 'password',
        prefix: <UserOutlined />
      },
      selectOptions: []
    },
    {
      label: '部门序号',
      type: 'inputNumber',
      filedName: 'partNo',
      protoConfig: {
        max: 10
      },
      selectOptions: []
    },
    {
      label: '部门编码',
      type: 'input',
      filedName: 'code',
      protoConfig: {
        // disabled: true,
      },
      selectOptions: []
    },
    {
      label: '用户状态',
      type: 'select',
      filedName: 'status',
      selectOptionName: {
        label: 'title',
        value: 'id'
      },
      selectOptions: [
        {
          title: '正常',
          id: '0'
        },
        {
          title: '删除',
          id: '1'
        },
        {
          title: '停用',
          id: '2'
        }
      ]
    },
    {
      label: '选项d类型',
      type: 'checkbox',
      filedName: 'check',
      // selectOptionName: {
      //   label: 'name',
      //   value: 'key'
      // },
      selectOptions: [
        {
          label: '正常',
          value: '0',
          key: '0'
        },
        {
          label: '删除',
          value: '1',
          key: '1'
        },
        {
          label: '停用',
          value: '2',
          key: '2'
        }
      ]
    },
    {
      label: '状态',
      type: 'radio',
      filedName: 'statusRadio',
      isHide: (values, form) => {
        return values.status === '1'
      },
      // selectOptionName: {
      //   label: 'name',
      //   value: 'key'
      // },
      rules: [{required: true, message: '请选择状态'}],
      selectOptions: [
        {
          label: '启用',
          value: '0',
        },
        {
          label: '停用',
          value: '1',
        }
      ]
    },
    {
      label: '时间筛选-指定年份',
      filedName: 'rangeYear',
      type: 'rangePicker',
      protoConfig: {
        picker: 'year',
        format: 'YYYY',
        // placeholder: ['开始年份', "结束年份"]
      }
    },
    {
      label: '月份区间',
      filedName: 'rangeMonth',
      type: 'rangePicker',
      // fieldOptions: {
      //   rules: [{required: true, message: '请选择月份区间'}]
      // },
      protoConfig: {
        picker: 'month',
        format: 'MM月',
        placeholder: ['开始月份', "结束月份"]
      }
    },
    {
      label: '自己定义',
      type: 'custom',
      filedName: 'customMark',
      display: 'block',
      customRender: (filterForm) => {
        return (
          <div style={{display: 'flex'}}>
            <Form.Item label="属性名称" name={['customMark', 'name']} style={{'display': 'flex'}}>
              <Input style={{...general.formItemStyle.sm}} />
            </Form.Item>
            <Form.Item label="属性代码" name={['customMark', 'code']} style={{'display': 'flex'}}><Input
              style={{...general.formItemStyle.sm}} /></Form.Item>
          </div>
        )
	      }
	    }
	  ]
	  return (
	    <StandardFilter  formItemGroup={controlFilters}
	                     buttonGroup={controlBtn}
	                     onFilterSearch={(filedValues)=> console.log('提交搜索', filedValues)}
	                     onFilterReset={(filedValues)=> console.log('重置搜索，即清空所有条件')}/>
	  )
	}
	
	export defalut StandardFilterDemo



## 按钮组配置
```
    
    import StandardFilter from '@/components/StandardFilter';
    const FilterButtonGroupDemo = ()=> {
      const [filterFormFields, setFilterFormFields] = useState({})
      const [filterFormChild, setFilterFormChild] = useState()
      const controlBtn = [
        {
          name: '被禁用',
          disabled: true, // 表示禁用
          code: 'codeBtnImport', // 导入 直接配置code可不用配置 name 与 icon
          fn: () => console.log('do something'),
        },
        {
          name: '导入',
          exName: '名称优先name（同code内定义的name）',
          // isHide: true, // 隐藏掉的按钮
          code: 'codeBtnImport', // 导入 直接配置code可不用配置 name 与 icon
          fn: () => console.log('do something'),
        },
        {
          name: '无code按钮',
          // isHide: true, // 隐藏掉的按钮
          icon: <DownloadOutlined />, // 自定义Dom图标结构
          fn: () => console.log('do something'),
        },
        {
          name: '按钮3',
          // isHide: true, // 隐藏掉的按钮
          icon: 'plus',
          fn: () => console.log('do something'),
        },
        {
          name: '超过3个按钮',
          isHide: true, // 隐藏掉的按钮
          icon: <SmileOutlined />,
          fn: () => console.log('do something'),
        },
        {
          name: '超过4个按钮',
          icon: 'speci,plus', //  ','第一个参数代表图标前缀，第二个参数代表图标类名
          fn: () => console.log('do something'),
        }
      ]
      
      const controlFilters = [
       
        {
          label: '部门序号',
          type: 'inputNumber',
          filedName: 'partNo'
        },
        {
          label: '部门编码',
          type: 'input',
          filedName: 'code',
          protoConfig: {
            // disabled: true,
          },
          selectOptions: []
        }
      ]
      return (
        <StandardFilter  formItemGroup={controlFilters}
                         onFilterSearch={(filedValues)=> console.log('提交搜索', filedValues)}
                         onFilterReset={(filedValues)=> console.log('重置搜索，即清空所有条件')}/>
      )
    }
    exprot defalut FilterButtonGroupDemo

```

## 获取组件内表单控件值集合及表单实例
    
    import StandardFilter from '@/components/StandardFilter';
    const getFormFieldsDemo = ()=> {
      const [filterFormFields, setFilterFormFields] = useState({})
      const [filterFormChild, setFilterFormChild] = useState()
      const controlFilters = [
          {
              label: '部门序号',
              type: 'inputNumber',
              filedName: 'partNo'
            },
            {
              label: '部门编码',
              type: 'input',
              filedName: 'code'
            }
      ]
      return (
        <StandardFilter formItemGroup={controlFilters}
                         getFormFields={(fieldValues, form)=> {
                           setFilterFormFields(fieldValues) // 获取表单内部控件值
                           setFilterFormChild(form) // 获取表单实例
                         }}/>
      )
    }




## API


| 参数字段      | 说明  |   类型   |必选项| 默认值/参考值|
|----------|------|:-------------|:------|:------|
| formItemGroup | 表单组 | Array or ReactNode | 是 | Array值查看 formItemGroup API |
| buttonGroup | 按钮组 | Array or ReactNode  | 否 | Array值查看 buttonGroup API |
| onFilterSearch | 点击查询搜索条件 | Function(fields) | 是 | - |
| onFilterReset | 点击重置搜索条件 | Function(fields) | 是 | -|
| initialValues(新增) | 表单控件默认值，只有初始化以及重置时生效 | object | - | -|
| getFormFields(新增) | 获取表单字段值及表单实例 | Function(fields,form) | - | |


### formItemGroup API
| 参数字段      | 说明  |   类型   |必选项| 参考值|
|----------|------|-------------|------|------|
| label | 标签名称/条件名称 | String | 是 |- |
| type | 控件类型 | String | 是 | 可以选择 input/select（custom为自定义结构） |
| filedName| 控件名称,配置到Form.Item的`name`属性 | String | 是 |参考  |
| ~~filedOptions~~(弃用) | 控件配置项 | String | 否 |参考  [getFieldDecorator(id, options) 参数](https://ant.design/components/form-cn/#getFieldDecorator(id,-options)-参数) |
| selectOptions | 选项列表 | Array | 否 | select/radio/checkbox等使用 ,选项值：{'label': 'xxx', value: 'xxx'}|
| rules(新增)| 校验规则，设置字段的校验逻辑。 | Array | 否 | [官网API](https://ant.design/components/form-cn/#Rule)|
| protoFormItem| Form.Item 原始参数 | Array | 否 | [官网API](https://ant.design/components/form-cn/#Form.Item)|
| isHide | 是否隐藏当前配置的组件 | Boolean/Function(fieldValues, form)| 否 | fieldValues指当前配置表单内部的所有控件值，form指当前弹窗内部的表单实例 |


## buttonGroup API
| 参数字段      | 说明  |   类型   |必选项|
|----------|------|-------------|------|
| name | 按钮文本 | String | 是 |
| icon | 图标类名 | String/ReactNode | 否 |
| type | 按钮类型 | String | 否 |
| fn | 按钮点击事件 | Function | 否 |
| code | 权限code，可决定name即按钮上的显示值，覆盖name值 | String | 否 |
| exName | 当设置code时，会优先使用exName作为按钮上的文本显示值 | String | 否 |
| isHide | 隐藏当前按钮 | Boolean | 否 |
| disabled | 禁用当前按钮 | Boolean | 否 |
