---
menu: 通用组件
name: StandardModal 弹窗
---

# 通用弹窗
> 页面上使用的操作类弹窗

## 基础用法

```
	const ModalBasic = (props) => { 
	 const [visible, setVisble] = useState(false)
	 return (<div>
		<StandardModal
	        title="弹窗基础用法"
	        visible={visible}
	        onSubmit={() => setVisble(false)}
	        onCancel={() => setVisble(false)}>
	        <div>
	          内容区域自己定义
	        </div>
	    </StandardModal>
	</div>)
   	export default ModalBasic
```	

## 配置化表单用法

	
```
	const ModalFormBasic = (props) => {
	
		const [modalSetting, setModalSetting] = useState({
		    visible: false,
		    type: 'form',
		    size: 'md',
		  })
	  const handleModalSubmit = (fields) => {
	    console.log('搜索表单值', fields)
	    setModalSetting({
	      ...modalSetting,
	      visible: false
	    })
	  }
	
	  const handleModalDisplaySubmit = (fields) => {
	    console.log('表单提交', fields)
	    setModalDisplaySetting({
	      ...modalDisplaySetting,
	      visible: false
	    })
	  }
	  const formItemGroup = [
	    {
	      label: '日期类控件',
	      type: 'title',
	    },
	    {
	      label: '日期',
	      description: '菜单的类型决定URL、映射是否显示，平台、目录不显示，仅菜单时显示',
	      type: 'datePicker',
	      filedName: 'date1'
	    },	   
	    {
	      label: '输入框控件',
	      type: 'title',
	    },
	    {
	      label: '类别名称',
	      type: 'input',
	      filedName: 'cateName',
	      // placeholder: '请输入类名名称',
	      rules: [{required: true, message: '请输入类别名称'}],
	      selectOptions: [],
	      componentStyle: {
	        width: '160px'
	      },
	      extra: () => {
	        return <span style={{paddingLeft: '4px'}}>扩展值</span>
	      },
	      onChange: (e) => {
	        console.log('输入更改', e.target.value)
	      }
	    },
	    {
	      label: '排序',
	      type: 'inputNumber',
	      filedName: 'sorta'
	    },
	    {
	      label: `类别代码`,
	      type: 'input',
	      filedName: 'catecode',
	      isHide: fieldValues => fieldValues.userStatus === '0', // 按条件判断显示与隐藏表单
	      rules: [{required: true, message: '请输入类别代码'}],
	      selectOptions: []
	    },
	    {
	      label: '选项控件：下拉、单选、多选',
	      type: 'title',
	    },
	    {
	      label: '用户状态',
	      type: 'select',
	      filedName: 'userStatus',
	      display: 'side', // 与其他并排显示
	      selectOptions: [
	        {
	          label: '正常',
	          value: '0'
	        },
	        {
	          label: '删除',
	          value: '1'
	        },
	        {
	          label: '停用',
	          value: '2'
	        }
	      ],
	      onChange: (e) => {
	        console.log('选择用户状态', e)
	      }
	    },
	    {
	      label: '搜索状态',
	      type: 'select',
	      filedName: 'userStatusSearch',
	      display: 'side', // 与其他并排显示
	      isHide: fields => fields.userStatus === '2', // 根据用户状态判断显示与隐藏
	      protoConfig: {
	        showSearch: true
	      },
	      selectOptions: [
	        {
	          label: '正常',
	          value: '0'
	        },
	        {
	          label: '删除',
	          value: '1'
	        },
	        {
	          label: '停用',
	          value: '2'
	        }
	      ],
	      onChange: (e) => {
	        console.log('选择用户状态', e)
	      }
	    },
	    {
	      label: '选项类型',
	      type: 'checkbox',
	      filedName: 'check',
	      display: 'block', // 单独显示一行
	      selectOptions: [
	        {
	          label: '正常',
	          value: '0'
	        },
	        {
	          label: '删除',
	          value: '1'
	        },
	       
	      ]
	    },
	    {
	      label: '单选类型',
	      type: 'radio',
	      filedName: 'radio',
	      display: 'block', // 单独显示一行
	      selectOptions: [
	        {
	          label: '启用',
	          value: '1'
	        },
	        {
	          label: '禁用',
	          value: '3'
	        }
	      ],
	      onChange: (e) => {
	        console.log('选择更改', e)
	      }
	    },
	    {
	      label: '备注',
	      type: 'textarea',
	      filedName: 'cateMark',
	      display: 'block',// 单独显示一行
	    },
	    {
	      label: <span>标题可以带结构  <SmileOutlined /></span>,
	      type: 'title',
	    },
	    {
	      label: '自己定义嵌套控件',
	      type: 'custom',
	      filedName: 'customMark',
	      required: true,
	      display: 'block',
	      customRender: (itemForm, itemData) => {
	        console.log('自己定义嵌套控件', itemForm)
	        return (<div>
	          <div style={{display: 'flex'}}>
	            <Form.Item name={['customMark', 'name']} label="属性名称" style={{marginRight: '10px'}} rules={[{required: true, message: '请输入自己定义的属性名称'}]}>
	              <Input style={{...general.formItemStyle.sm}} />
	            </Form.Item>
	            <Form.Item name={['customMark', 'code']} label="属性代码">
	              <Input style={{...general.formItemStyle.sm}} /></Form.Item>
	          </div>
	        </div>)
	      }
	    },
	    {
	      label: '自己定义栅格',
	      type: 'input',
	      filedName: 'customCol1',
	      colSpan: 16,
	      display: {
	        labelCol: {span: 8},
	        wrapperCol: {span: 16}
	      },
	    },
	    {
	      label: '栅格',
	      type: 'input',
	      filedName: 'customCol2',
	      display: {
	        labelCol: {span: 6},
	        wrapperCol: {span: 12}
	      },
	      colSpan: 8
	    },
	    {
	      label: <div>
	        <div>自己定义DOM结构</div>
	        <div>自己定义DOM结构</div>
	      </div>,
	      type: 'html',
	    },
	  ]

	   return(<div> 
		  <Button type="primary" onClick={() => {
		          setModalSetting({...modalSetting, title: '配置表单', visible: true})
		          setModalInitValues({...modalInitValues, sorta: 30})
		        }}>
		          弹窗内表单是配置出来的
		        </Button>
		 <StandardModal
	        {...modalSetting}
	        getFormFields={(fields, form) => {
	          setModalFormChild(fields)
	        }}
	        formItemGroup={formItemGroup}
	        initialValues={{...modalInitValues}}
	        onSubmit={handleModalSubmit}
	        onCancel={() => setModalSetting({...modalSetting, visible: false})}
	      >
	        <h3>当前是由 formItemGroup 配置出来的</h3>
	        <div style={{padding: '16px', border: ' 1px solid #b7eb8f', background: '#f6ffed', marginBottom: '16px'}}>
	          <h3>栅格配置说明</h3>
	          <p>①如果弹窗尺寸为 lg,
	            则行内表单配置col为8,分三栏显示，其他两个尺寸直接设置24;<br />②Form.Item的栅格配置，如果是栅格则配置 <b>“...general.modalSize[modalProps.size].formLayout”</b>，
	            如果是一行只显示一个表单域，则配置 <b>...general.modalSize[modalProps.size].formBlockLayout</b><br />③表单域（如Input）可通过参数
	            componentStyle 配置其宽度等样式，或者使用 extra 在其后面的位置新增内容</p>
	        </div>
	
		      </StandardModal>
		</div>)
	
	   	export default ModalFormBasic

```

## API
| 参数      | 说明                                      | 类型         | 默认值 | 参考值 |
|----------|------------------------------------------|-------------|-------|-------|
| title | 弹窗标题 | String | - |- |
| size | 弹窗大小 | String | sm |可选:xs,sm,md,lg,lg |
| type | 弹窗类型 | String |normal |可选normal：普通弹窗, form: 配置表单弹窗 |
| onSubmit | 点击保存（确认）,type为form时，参数中才有fields |  Function([fields]) | - |- |
| onCancel | 取消 |  Function()| - |- |
| footerButtonGroup | 弹窗按钮组，自己定义配置底部按钮组 | Array\ReactNode  | Array数据参数值查看 footerBtnGroup API|
| hideFooter |  是否隐藏底部栏 | Boolean| false |- |
| formItemGroup | 表单组 | Array  | Array数据参数值查看 formItemGroup API|
| ~~footerRender~~(弃用) | 渲染弹窗按钮底部 |  Function(modalSubmit, modalCancel, props)| - |- |
| formPrefix | 表单组前置结构 |  Function(modalForm, modalProps)| - |modalForm是表示form实例，但是调用需使用 modalForm.current |
| formPostfix | 表单组后置结构 |  Function(modalForm, modalProps)| - |- |
| confirmText/okText | 保存按钮文本 | String | '取消' | |
| cancelText | 取消按钮文本 | String | '取消' | |
| ~~disabledAll~~(弃用,使用 fieldStatus='disabled'替换) | 配置化表单全部禁用 | Boolean | false | |
| fieldStatus | 配置化表单展示状态：“viewOnly 只显示值不显示控件”或者"disabled:控件禁用" | String | 'defalut' | |
| initialValues | type="form"条件下的表单组默认值配置 | Object | - | |
| getFormFields | type="form"条件下获取当前弹窗内表单字段值及表单实例 | Function(fields,form) | - | |


## formItemGroup API
| 参数字段      | 说明  |   类型   |必选项| 参考值|
|----------|------|-------------|------|------|
| label | 标签名称/条件名称 | String 或 ReactNode | 是 |- |
| type | 控件类型 | String | 是 | 可以选择 input/select/textarea/checkbox/custom(自定义) |
| componentStyle | 表单域样式,可设置宽度等 | Object | 否 |  |
| extra | 跟在表单域后的结构 | Function ReactNode | 否 | - |
| filedName | 控件名称 | String | 是 |参考  [getFieldDecorator(id, options) 参数](https://ant.design/components/form-cn/#getFieldDecorator(id,-options)-参数) |
| filedOptions | 控件配置项 | String | 否 |参考  [getFieldDecorator(id, options) 参数](https://ant.design/components/form-cn/#getFieldDecorator(id,-options)-参数) |
| selectOptions | 选项列表 | Array | 否 | select/radio/checkbox等使用 ,选项值：{'label': 'xxx', value: 'xxx'}|
| customRender | 必须结合 type="custom"使用 | Function(itemForm,itemData) ReactNode | 否 | itemForm表单获取值之类要添加 itemForm.current.getFieldsValue() |
| required | 可结合 type="custom"使用,自定义校验规则时，可在label标签前显示* | Boolean| 否 | - |
| isHide | 是否隐藏当前配置的组件 | Boolean/Function(fieldValues, form)| 否 | fieldValues指当前配置表单内部的所有控件值，form指当前弹窗内部的表单实例 |
| protoConfig | 原生的表单控件配置或者antd对应的配置参数,例如配置 protoConfig: { disabled: true }| Object| 否 | - |

## footerBtnGroup API

| 参数字段      | 说明  |   类型   |必选项|
|----------|------|-------------|------|
| name | 按钮文本 | String | 是 |
| icon | 图标类名 | String/ReactNode/Array（['speci', 'plus']，至少传一个前缀名，一个图标类名两个值） | 否 |
| type | 按钮类型 | String | 否 |
| fn | 按钮点击事件 | Function | 否 |



> 待优化项：
>
> - `initialValues` 是否直接内部处理，按原来的`fieldOptions: { initialValue: xxx }`配置进行组合
