"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _SpecIconFont = _interopRequireDefault(require("../../SpecIconFont"));

var _react = _interopRequireDefault(require("react"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

// 渲染图标展示

/*
*  params { String,ReactNode } icon: 图标支持传值为字符串，
*  当表示为String,且数据里面包含','区分两个参数,第一个参数代表图标类名前缀，第二个参数代表当前图标类名 ‘speci,plus’
*  当表示为Array时，必须包含两个参数，第一个参数代表图标类名前缀，第二个参数代表当前图标类名 ['speci','plus']
 */
var IconNode = function IconNode(props) {
  var icon = props.icon;
  if (!icon) return null;

  if (typeof icon === 'string') {
    var iconArr = icon.split(',');
    return _react["default"].createElement(_SpecIconFont["default"], {
      prefix: iconArr.length > 1 ? iconArr[0] : 'speci',
      name: iconArr.length > 1 ? iconArr[1] : icon
    });
  }

  if (Array.isArray(icon) && icon.length > 1) return _react["default"].createElement(_SpecIconFont["default"], {
    prefix: icon[0],
    name: icon[1]
  }); // 预留 Array ['speci','plus']

  return icon;
};

var _default = IconNode;
exports["default"] = _default;